### 1. Release checks
This is an automated testing tool for projects that were generated by the Aurelia-CLI. It tests all "au" commands for every project.

1. open the terminal, go into an empty directory and run `au generate-skeletons`
2. from the CLI repository folder, run `gulp release-check --path C:/Development/Aurelia/TestApps --latest-cli-url aurelia/cli#master`, substituting the path with the correct one.
  * Note, on Windows, run PowerShell with "run as administrator".
3. Select for which projects you would like to run the tests.
  * To test all projects automatically, add `--all` to previous command.
  * To test subset projects automatically, add `--select requirejs,babel` (only tests projects using requirejs and babel) to previous command.
4. Wait until tests complete
5. in the CLI repository folder there is now a release-checks-results folder containing the output and other artifacts, such as screenshots. Check these screenshots to make sure that pages have rendered correctly

### Add new tests
In the build/tasks/release-checks folder is a suite-steps.js file. This file contains a collection of tests per project. New tests can be added to this file.

### Todo
- Tests for dotnet projects (the tool can run dotnet new, but dotnet does not serve the index.html file that exists in wwwrooot)

### 2. Prepare release

1. run `gulp prepare-release --bump major|minor|patch|prerelease`. This will update aurelia-cli version, update change log, update cli version in `lib/dependencies.json`.
2. do `npm publish`.
